"""
    TickHistory

    TickHistory provides dynamic access to historical tick data for a specific security for specific dates or date range.  # noqa: E501

    The version of the OpenAPI document: 1.1.0
    Generated by: https://openapi-generator.tech
"""


import re  # noqa: F401
import sys  # noqa: F401
from multiprocessing.pool import ApplyResult
import typing

from fds.sdk.FactSetTickHistory.api_client import ApiClient, Endpoint as _Endpoint
from fds.sdk.FactSetTickHistory.model_utils import (  # noqa: F401
    check_allowed_values,
    check_validations,
    date,
    datetime,
    file_type,
    none_type,
    validate_and_convert_types
)
from fds.sdk.FactSetTickHistory.exceptions import ApiException
from fds.sdk.FactSetTickHistory.model.request_files_response import RequestFilesResponse
from fds.sdk.FactSetTickHistory.model.request_filestatus import RequestFilestatus





class RequestFilesApi(object):
    """NOTE: This class is auto generated by OpenAPI Generator
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    def __init__(self, api_client=None):
        if api_client is None:
            api_client = ApiClient()
        self.api_client = api_client
        self.v1_request_files_get_endpoint = _Endpoint(
            settings={
                'response_type': (
                  { 200: (RequestFilesResponse,), 400: (RequestFilestatus,),  },
                  None
                ),
                'auth': [
                    'FactSetApiKey',
                    'FactSetOAuth2'
                ],
                'endpoint_path': '/v1/request-files',
                'operation_id': 'v1_request_files_get',
                'http_method': 'GET',
                'servers': None,
            },
            params_map={
                'all': [
                    'start_date',
                    'end_date',
                    'ticker',
                    'iso_code',
                    'fields',
                    'start_time',
                    'end_time',
                    'single',
                    'regional_iso_code',
                ],
                'required': [
                    'start_date',
                    'end_date',
                ],
                'nullable': [
                ],
                'enum': [
                    'single',
                ],
                'validation': [
                    'start_date',
                ]
            },
            root_map={
                'validations': {
                    ('start_date',): {

                    },
                },
                'allowed_values': {
                    ('single',): {

                        "TRUE": "true",
                        "FALSE": "false"
                    },
                },
                'openapi_types': {
                    'start_date':
                        (date,),
                    'end_date':
                        (date,),
                    'ticker':
                        (str,),
                    'iso_code':
                        (str,),
                    'fields':
                        (str,),
                    'start_time':
                        (str,),
                    'end_time':
                        (str,),
                    'single':
                        (str,),
                    'regional_iso_code':
                        (str,),
                },
                'attribute_map': {
                    'start_date': 'start_date',
                    'end_date': 'end_date',
                    'ticker': 'ticker',
                    'iso_code': 'iso_code',
                    'fields': 'fields',
                    'start_time': 'start_time',
                    'end_time': 'end_time',
                    'single': 'single',
                    'regional_iso_code': 'regionalISOCode',
                },
                'location_map': {
                    'start_date': 'query',
                    'end_date': 'query',
                    'ticker': 'query',
                    'iso_code': 'query',
                    'fields': 'query',
                    'start_time': 'query',
                    'end_time': 'query',
                    'single': 'query',
                    'regional_iso_code': 'query',
                },
                'collection_format_map': {
                }
            },
            headers_map={
                'accept': [
                    'application/json'
                ],
                'content_type': [],
            },
            api_client=api_client
        )

    @staticmethod
    def apply_kwargs_defaults(kwargs, return_http_data_only, async_req):
        kwargs["async_req"] = async_req
        kwargs["_return_http_data_only"] = return_http_data_only
        kwargs["_preload_content"] = kwargs.get("_preload_content", True)
        kwargs["_request_timeout"] = kwargs.get("_request_timeout", None)
        kwargs["_check_input_type"] = kwargs.get("_check_input_type", True)
        kwargs["_check_return_type"] = kwargs.get("_check_return_type", True)
        kwargs["_spec_property_naming"] = kwargs.get("_spec_property_naming", False)
        kwargs["_content_type"] = kwargs.get("_content_type")
        kwargs["_host_index"] = kwargs.get("_host_index")

    def v1_request_files_get(
        self,
        start_date,
        end_date,
        **kwargs
    ) -> RequestFilesResponse:
        """Returns the requestId and status  # noqa: E501

        Try it Out - references a Sandbox environment to simulate live reponses.</p> **In Sandbox** data available from 20210101 to 20210131. Current date data is not available.</p> PROD has data from 20120101 to current date &</p> **available IDs is limited to..**</p> US Equity - IBM-USA, F-USA, AAPL-USA, GOOG-USA</p> ASX - CBA-ASX, BHP-ASX, APA-ASX</p> LSE - HSBA-LON, VOD-LON</p> Tokyo - 7203-TKS, 4307-TKS</p> Swiss - NESN-SWX, COTN-SWX</p> Singapore - J36-SES &</p> Hong Kong - 700-HKG</p>  # noqa: E501
        This method makes a synchronous HTTP request. Returns the http data only

        Args:
            start_date (date): The date for (or from which) the data is required.</p> **In Sandbox, data available from 1st to 31st Jan'21 only**.
            end_date (date): The date to which data is required.</p> **In Sandbox, data available from 1st to 31st Jan'21 only**.

        Keyword Args:
            ticker (str): The requested list of security identifiers. <p>**Either ticker(s) + iso_code  (OR) product is allowed**</p> **NOTE**:Only one identifier can be requested per request. [optional]
            iso_code (str): The requested ISO code. <p>ticker(s) + iso_code</p> <p>**Does not support multiple iso_codes**</p>. [optional]
            fields (str): Fields for which data is requested. Refer <a href= \"https://developer.factset.com/api-catalog/factset-tick-history-api#apiDocumentation\">Output fields list</a>. for available fields.</p> **In trial default=all fields**. [optional] if omitted the server will use the default value of "*"
            start_time (str): The start time of the data being requested. The time should be in HH:MM:SS format.. [optional]
            end_time (str): The end time of the data being requested. The time should be in HH:MM:SS format.. [optional]
            single (str): Returns data in a single file when single=true. This parameter only works for smaller date/time requests where the file size is upto 128MB.. [optional] if omitted the server will use the default value of "false"
            regional_iso_code (str): Works in conjunction with iso_code parameter.<p>ticker(s) + iso_code + regionalISOCode</p> <p>**Does not support multiple regionalISOCodes**</p>. [optional]
            _preload_content (bool): if False, the urllib3.HTTPResponse object
                will be returned without reading/decoding response data.
                Default is True.
            _request_timeout (int/float/tuple): timeout setting for this request. If
                one number provided, it will be total request timeout. It can also
                be a pair (tuple) of (connection, read) timeouts.
                Default is None.
            _check_input_type (bool): specifies if type checking
                should be done one the data sent to the server.
                Default is True.
            _check_return_type (bool): specifies if type checking
                should be done one the data received from the server.
                Default is True.
            _spec_property_naming (bool): True if the variable names in the input data
                are serialized names, as specified in the OpenAPI document.
                False if the variable names in the input data
                are pythonic names, e.g. snake case (default)
            _content_type (str/None): force body content-type.
                Default is None and content-type will be predicted by allowed
                content-types and body.
            _host_index (int/None): specifies the index of the server
                that we want to use.
                Default is read from the configuration.
        Returns:
            RequestFilesResponse
                Response Object
        """
        self.apply_kwargs_defaults(kwargs=kwargs, return_http_data_only=True, async_req=False)
        kwargs['start_date'] = \
            start_date
        kwargs['end_date'] = \
            end_date
        return self.v1_request_files_get_endpoint.call_with_http_info(**kwargs)

    def v1_request_files_get_with_http_info(
        self,
        start_date,
        end_date,
        **kwargs
    ) -> typing.Tuple[RequestFilesResponse, int, typing.MutableMapping]:
        """Returns the requestId and status  # noqa: E501

        Try it Out - references a Sandbox environment to simulate live reponses.</p> **In Sandbox** data available from 20210101 to 20210131. Current date data is not available.</p> PROD has data from 20120101 to current date &</p> **available IDs is limited to..**</p> US Equity - IBM-USA, F-USA, AAPL-USA, GOOG-USA</p> ASX - CBA-ASX, BHP-ASX, APA-ASX</p> LSE - HSBA-LON, VOD-LON</p> Tokyo - 7203-TKS, 4307-TKS</p> Swiss - NESN-SWX, COTN-SWX</p> Singapore - J36-SES &</p> Hong Kong - 700-HKG</p>  # noqa: E501
        This method makes a synchronous HTTP request. Returns http data, http status and headers

        Args:
            start_date (date): The date for (or from which) the data is required.</p> **In Sandbox, data available from 1st to 31st Jan'21 only**.
            end_date (date): The date to which data is required.</p> **In Sandbox, data available from 1st to 31st Jan'21 only**.

        Keyword Args:
            ticker (str): The requested list of security identifiers. <p>**Either ticker(s) + iso_code  (OR) product is allowed**</p> **NOTE**:Only one identifier can be requested per request. [optional]
            iso_code (str): The requested ISO code. <p>ticker(s) + iso_code</p> <p>**Does not support multiple iso_codes**</p>. [optional]
            fields (str): Fields for which data is requested. Refer <a href= \"https://developer.factset.com/api-catalog/factset-tick-history-api#apiDocumentation\">Output fields list</a>. for available fields.</p> **In trial default=all fields**. [optional] if omitted the server will use the default value of "*"
            start_time (str): The start time of the data being requested. The time should be in HH:MM:SS format.. [optional]
            end_time (str): The end time of the data being requested. The time should be in HH:MM:SS format.. [optional]
            single (str): Returns data in a single file when single=true. This parameter only works for smaller date/time requests where the file size is upto 128MB.. [optional] if omitted the server will use the default value of "false"
            regional_iso_code (str): Works in conjunction with iso_code parameter.<p>ticker(s) + iso_code + regionalISOCode</p> <p>**Does not support multiple regionalISOCodes**</p>. [optional]
            _preload_content (bool): if False, the urllib3.HTTPResponse object
                will be returned without reading/decoding response data.
                Default is True.
            _request_timeout (int/float/tuple): timeout setting for this request. If
                one number provided, it will be total request timeout. It can also
                be a pair (tuple) of (connection, read) timeouts.
                Default is None.
            _check_input_type (bool): specifies if type checking
                should be done one the data sent to the server.
                Default is True.
            _check_return_type (bool): specifies if type checking
                should be done one the data received from the server.
                Default is True.
            _spec_property_naming (bool): True if the variable names in the input data
                are serialized names, as specified in the OpenAPI document.
                False if the variable names in the input data
                are pythonic names, e.g. snake case (default)
            _content_type (str/None): force body content-type.
                Default is None and content-type will be predicted by allowed
                content-types and body.
            _host_index (int/None): specifies the index of the server
                that we want to use.
                Default is read from the configuration.
        Returns:
            RequestFilesResponse
                Response Object
            int
                Http Status Code
            dict
                Dictionary of the response headers
        """
        self.apply_kwargs_defaults(kwargs=kwargs, return_http_data_only=False, async_req=False)
        kwargs['start_date'] = \
            start_date
        kwargs['end_date'] = \
            end_date
        return self.v1_request_files_get_endpoint.call_with_http_info(**kwargs)

    def v1_request_files_get_async(
        self,
        start_date,
        end_date,
        **kwargs
    ) -> "ApplyResult[RequestFilesResponse]":
        """Returns the requestId and status  # noqa: E501

        Try it Out - references a Sandbox environment to simulate live reponses.</p> **In Sandbox** data available from 20210101 to 20210131. Current date data is not available.</p> PROD has data from 20120101 to current date &</p> **available IDs is limited to..**</p> US Equity - IBM-USA, F-USA, AAPL-USA, GOOG-USA</p> ASX - CBA-ASX, BHP-ASX, APA-ASX</p> LSE - HSBA-LON, VOD-LON</p> Tokyo - 7203-TKS, 4307-TKS</p> Swiss - NESN-SWX, COTN-SWX</p> Singapore - J36-SES &</p> Hong Kong - 700-HKG</p>  # noqa: E501
        This method makes a asynchronous HTTP request. Returns the http data, wrapped in ApplyResult

        Args:
            start_date (date): The date for (or from which) the data is required.</p> **In Sandbox, data available from 1st to 31st Jan'21 only**.
            end_date (date): The date to which data is required.</p> **In Sandbox, data available from 1st to 31st Jan'21 only**.

        Keyword Args:
            ticker (str): The requested list of security identifiers. <p>**Either ticker(s) + iso_code  (OR) product is allowed**</p> **NOTE**:Only one identifier can be requested per request. [optional]
            iso_code (str): The requested ISO code. <p>ticker(s) + iso_code</p> <p>**Does not support multiple iso_codes**</p>. [optional]
            fields (str): Fields for which data is requested. Refer <a href= \"https://developer.factset.com/api-catalog/factset-tick-history-api#apiDocumentation\">Output fields list</a>. for available fields.</p> **In trial default=all fields**. [optional] if omitted the server will use the default value of "*"
            start_time (str): The start time of the data being requested. The time should be in HH:MM:SS format.. [optional]
            end_time (str): The end time of the data being requested. The time should be in HH:MM:SS format.. [optional]
            single (str): Returns data in a single file when single=true. This parameter only works for smaller date/time requests where the file size is upto 128MB.. [optional] if omitted the server will use the default value of "false"
            regional_iso_code (str): Works in conjunction with iso_code parameter.<p>ticker(s) + iso_code + regionalISOCode</p> <p>**Does not support multiple regionalISOCodes**</p>. [optional]
            _preload_content (bool): if False, the urllib3.HTTPResponse object
                will be returned without reading/decoding response data.
                Default is True.
            _request_timeout (int/float/tuple): timeout setting for this request. If
                one number provided, it will be total request timeout. It can also
                be a pair (tuple) of (connection, read) timeouts.
                Default is None.
            _check_input_type (bool): specifies if type checking
                should be done one the data sent to the server.
                Default is True.
            _check_return_type (bool): specifies if type checking
                should be done one the data received from the server.
                Default is True.
            _spec_property_naming (bool): True if the variable names in the input data
                are serialized names, as specified in the OpenAPI document.
                False if the variable names in the input data
                are pythonic names, e.g. snake case (default)
            _content_type (str/None): force body content-type.
                Default is None and content-type will be predicted by allowed
                content-types and body.
            _host_index (int/None): specifies the index of the server
                that we want to use.
                Default is read from the configuration.
        Returns:
            ApplyResult[RequestFilesResponse]
        """
        self.apply_kwargs_defaults(kwargs=kwargs, return_http_data_only=True, async_req=True)
        kwargs['start_date'] = \
            start_date
        kwargs['end_date'] = \
            end_date
        return self.v1_request_files_get_endpoint.call_with_http_info(**kwargs)

    def v1_request_files_get_with_http_info_async(
        self,
        start_date,
        end_date,
        **kwargs
    ) -> "ApplyResult[typing.Tuple[RequestFilesResponse, int, typing.MutableMapping]]":
        """Returns the requestId and status  # noqa: E501

        Try it Out - references a Sandbox environment to simulate live reponses.</p> **In Sandbox** data available from 20210101 to 20210131. Current date data is not available.</p> PROD has data from 20120101 to current date &</p> **available IDs is limited to..**</p> US Equity - IBM-USA, F-USA, AAPL-USA, GOOG-USA</p> ASX - CBA-ASX, BHP-ASX, APA-ASX</p> LSE - HSBA-LON, VOD-LON</p> Tokyo - 7203-TKS, 4307-TKS</p> Swiss - NESN-SWX, COTN-SWX</p> Singapore - J36-SES &</p> Hong Kong - 700-HKG</p>  # noqa: E501
        This method makes a asynchronous HTTP request. Returns http data, http status and headers, wrapped in ApplyResult

        Args:
            start_date (date): The date for (or from which) the data is required.</p> **In Sandbox, data available from 1st to 31st Jan'21 only**.
            end_date (date): The date to which data is required.</p> **In Sandbox, data available from 1st to 31st Jan'21 only**.

        Keyword Args:
            ticker (str): The requested list of security identifiers. <p>**Either ticker(s) + iso_code  (OR) product is allowed**</p> **NOTE**:Only one identifier can be requested per request. [optional]
            iso_code (str): The requested ISO code. <p>ticker(s) + iso_code</p> <p>**Does not support multiple iso_codes**</p>. [optional]
            fields (str): Fields for which data is requested. Refer <a href= \"https://developer.factset.com/api-catalog/factset-tick-history-api#apiDocumentation\">Output fields list</a>. for available fields.</p> **In trial default=all fields**. [optional] if omitted the server will use the default value of "*"
            start_time (str): The start time of the data being requested. The time should be in HH:MM:SS format.. [optional]
            end_time (str): The end time of the data being requested. The time should be in HH:MM:SS format.. [optional]
            single (str): Returns data in a single file when single=true. This parameter only works for smaller date/time requests where the file size is upto 128MB.. [optional] if omitted the server will use the default value of "false"
            regional_iso_code (str): Works in conjunction with iso_code parameter.<p>ticker(s) + iso_code + regionalISOCode</p> <p>**Does not support multiple regionalISOCodes**</p>. [optional]
            _preload_content (bool): if False, the urllib3.HTTPResponse object
                will be returned without reading/decoding response data.
                Default is True.
            _request_timeout (int/float/tuple): timeout setting for this request. If
                one number provided, it will be total request timeout. It can also
                be a pair (tuple) of (connection, read) timeouts.
                Default is None.
            _check_input_type (bool): specifies if type checking
                should be done one the data sent to the server.
                Default is True.
            _check_return_type (bool): specifies if type checking
                should be done one the data received from the server.
                Default is True.
            _spec_property_naming (bool): True if the variable names in the input data
                are serialized names, as specified in the OpenAPI document.
                False if the variable names in the input data
                are pythonic names, e.g. snake case (default)
            _content_type (str/None): force body content-type.
                Default is None and content-type will be predicted by allowed
                content-types and body.
            _host_index (int/None): specifies the index of the server
                that we want to use.
                Default is read from the configuration.
        Returns:
            ApplyResult[(RequestFilesResponse, int, typing.Dict)]
        """
        self.apply_kwargs_defaults(kwargs=kwargs, return_http_data_only=False, async_req=True)
        kwargs['start_date'] = \
            start_date
        kwargs['end_date'] = \
            end_date
        return self.v1_request_files_get_endpoint.call_with_http_info(**kwargs)

